
enum MOM_WHEELS {
	MOM_WHEEL_FL,
	MOM_WHEEL_RL,
	MOM_WHEEL_BR,
	MOM_WHEEL_FR,
};

/*
 * Wheel 1 - front left
 */
/* Drive (can adress motor 6) */
const struct CAN_OPEN_PARAM_STR W1Drive = {
	.txPDO1 = 0x186,
	.txPDO2 = 0x286,
	.rxPDO2 = 0x306,
	.txSDO = 0x586,
	.rxSDO = 0x606
};

/* Steer (can adress motor 5) */
const struct CAN_OPEN_PARAM_STR W1Steer = {
	.txPDO1 = 0x185,
	.txPDO2 = 0x285,
	.rxPDO2 = 0x305,
	.txSDO  = 0x585,
	.rxSDO = 0x605
};

/*
 * Wheel 2 - rear left
 */
/* Drive (can adress motor 4) */
const struct CAN_OPEN_PARAM_STR W2Drive = {
	.txPDO1 = 0x184,
	.txPDO2 = 0x284,
	.rxPDO2 = 0x304,
	.txSDO = 0x584,
	.rxSDO = 0x604
};

/* Steer (can adress motor 3) */
const struct CAN_OPEN_PARAM_STR W2Steer = {
	.txPDO1 = 0x183,
	.txPDO2 = 0x283,
	.rxPDO2 = 0x303,
	.txSDO = 0x583,
	.rxSDO = 0x603
};

/*
 * Wheel 3 - rear right
 */
/* Drive (can adress motor 2) */
const struct CAN_OPEN_PARAM_STR W3Drive = {
	.txPDO1 = 0x182,
	.txPDO2 = 0x282,
	.rxPDO2 = 0x302,
	.txSDO = 0x582,
	.rxSDO = 0x602
};

/* Steer (can adress motor 1) */
const struct CAN_OPEN_PARAM_STR W3Steer = {
	.txPDO1 = 0x181,
	.txPDO2 = 0x281,
	.rxPDO2 = 0x301,
	.txSDO = 0x581,
	.rxSDO = 0x601
};

/*
 * Wheel 4 - front right
 */
/* Drive (can adress motor 8) */
const struct CAN_OPEN_PARAM_STR W4Drive = {
	.txPDO1 = 0x188,
	.txPDO2 = 0x288,
	.rxPDO2 = 0x308,
	.txSDO = 0x588,
	.rxSDO = 0x608
};

/* Steer (can adress motor 7) */
const struct CAN_OPEN_PARAM_STR W4Steer = {
	.txPDO1 = 0x187,
	.txPDO2 = 0x287,
	.rxPDO2 = 0x307,
	.txSDO = 0x587,
	.rxSDO = 0x607
};

/*----------------------------------------------------------------------*/

/**
 ** Drive parameters
 **/
const struct CAN_DRIVE_PARAMS Drive1 = {
	.encIncrPerRevMot = 4096,
	.gearRatio = 15,
	.beltRatio = 2,
	.sign = 1,
	.velMaxEncIncrS = 240000,
	.accIncrS = 500000, //80000,
	.decIncrS = 500000, //80000,
	.encOffsetIncr = 0,
	.isSteering = false,
	.currToTorque = 0.10065,
	.currMax = 9.62,
	.homingDigIn = 9,
};

const struct CAN_DRIVE_PARAMS Steer1 = {
	.encIncrPerRevMot = 4096,
	.gearRatio = 12.66666666,
	.beltRatio = 1,
	.sign = -1,
	.velMaxEncIncrS = 240000,
	.accIncrS = 1000000, //80000,
	.decIncrS = 1000000, //80000,
	.encOffsetIncr = 0,
	.isSteering = true,
	.currToTorque = 0.10065,
	.currMax = 9.62,
	.homingDigIn = 9,
};

const struct CAN_DRIVE_PARAMS Drive2 = {
	.encIncrPerRevMot = 4096,
	.gearRatio = 15,
	.beltRatio = 2,
	.sign = -1,
	.velMaxEncIncrS = 240000,
	.accIncrS = 500000, //80000,
	.decIncrS = 500000, //80000,
	.encOffsetIncr = 0,
	.isSteering = false,
	.currToTorque = 0.10065,
	.currMax = 9.62,
	.homingDigIn = 9,
};

const struct CAN_DRIVE_PARAMS Steer2 = {
	.encIncrPerRevMot = 4096,
	.gearRatio = 12.66666666,
	.beltRatio = 1,
	.sign = 1,
	.velMaxEncIncrS = 240000,
	.accIncrS = 1000000, //80000,
	.decIncrS = 1000000, //80000,
	.encOffsetIncr = 0,
	.isSteering = true,
	.currToTorque = 0.10065,
	.currMax = 9.62,
	.homingDigIn = 9,
};

const struct CAN_DRIVE_PARAMS Drive3 = {
	.encIncrPerRevMot = 4096,
	.gearRatio = 15,
	.beltRatio = 2,
	.sign = 1,
	.velMaxEncIncrS = 240000,
	.accIncrS = 500000, //80000,
	.decIncrS = 500000, //80000,
	.encOffsetIncr = 0,
	.isSteering = false,
	.currToTorque = 0.10065,
	.currMax = 9.62,
	.homingDigIn = 9,
};

const struct CAN_DRIVE_PARAMS Steer3 = {
	.encIncrPerRevMot = 4096,
	.gearRatio = 12.66666666,
	.beltRatio = 1,
	.sign = -1,
	.velMaxEncIncrS = 240000,
	.accIncrS = 1000000, //80000,
	.decIncrS = 1000000, //80000,
	.encOffsetIncr = 25941,
	.isSteering = true,
	.currToTorque = 0.10065,
	.currMax = 9.62,
	.homingDigIn = 9,
};

const struct CAN_DRIVE_PARAMS Drive4 = {
	.encIncrPerRevMot = 4096,
	.gearRatio = 15,
	.beltRatio = 2,
	.sign = -1,
	.velMaxEncIncrS = 240000,
	.accIncrS = 500000, //80000,
	.decIncrS = 500000, //80000,
	.encOffsetIncr = 0,
	.isSteering = false,
	.currToTorque = 0.10065,
	.currMax = 9.62,
	.homingDigIn = 9,
};

const struct CAN_DRIVE_PARAMS Steer4 = {
	.encIncrPerRevMot = 4096,
	.gearRatio = 12.66666666,
	.beltRatio = 1,
	.sign = 1,
	.velMaxEncIncrS = 240000,
	.accIncrS = 1000000, //80000,
	.decIncrS = 1000000, //80000,
	.encOffsetIncr = 25941,
	.isSteering = true,
	.currToTorque = 0.10065,
	.currMax = 9.62,
	.homingDigIn = 9,
};



/*----------------------------------------------------------------------*/

/*
 * Spine motor 
 */
const struct CAN_OPEN_PARAM_STR spineAddr = {
	.txPDO1 = 0x189,
	.txPDO2 = 0x289,
	.rxPDO2 = 0x309,
	.txSDO = 0x589,
	.rxSDO = 0x609
};

/* For this motor, the position and speed are in m and m/s respectively */
const struct CAN_DRIVE_PARAMS spineParams = {
	.encIncrPerRevMot = 4096,
	.gearRatio = 1870,	/* conversion factor to get meters
				   from encoders */
	.beltRatio = 1,
	.sign = 1,
	.velMaxEncIncrS = 300000,
	.accIncrS = 300000,
	.decIncrS = 300000,
	.encOffsetIncr = 10000,
	.isSteering = true,
	.currToTorque = 0.10065,
	.currMax = 9.62,
	.homingDigIn = 7,
	.homingSpeed = -20000,	/* move downwards for calibration */
	.homingDelay = 40,	/* theorical 25s at maximum course */
};

/*----------------------------------------------------------------------*/

const struct MOR_WHEEL_STR momWheels[MOR_N_WHEELS] = {
	{
		.steer = {
			.canOpen = &W1Steer,
			.params = &Steer1 },
		.drive = {
			.canOpen = &W1Drive,
			.params = &Drive1 },
	},
	{
		.steer = {
			.canOpen = &W2Steer,
			.params = &Steer2 },
		.drive = {
			.canOpen = &W2Drive,
			.params = &Drive2 },
	},
	{
		.steer = {
			.canOpen = &W3Steer,
			.params = &Steer3 },
		.drive = {
			.canOpen = &W3Drive,
			.params = &Drive3 },
	},
	{
		.steer = {
			.canOpen = &W4Steer,
			.params = &Steer4 },
		.drive = {
			.canOpen = &W4Drive,
			.params = &Drive4 },
	},
};

const struct MOR_WHEEL_GEOM_STR momWheel[MOR_N_WHEELS] = {
	{
		.x = .235,
		.y = .185,
		.radius = 0.075,
		.initOrient = M_PI,
		.dorientmax = 10.0,
		.arm = 0.022,
	},
	{
		.x = -.235,
		.y = .185,
		.radius = 0.075,
		.initOrient = M_PI,
		.dorientmax = 10.0,
		.arm = 0.022,
	},
	{
		.x = -.235,
		.y = -.185,
		.radius = 0.075,
		.initOrient = 0,
		.arm = 0.022,
		.dorientmax = 10.0,
	},
	{
		.x = .235,
		.y = -.185,
		.radius = 0.075,
		.initOrient = 0,
		.dorientmax = 10.0,
		.arm = 0.022,
	},
};

/* built-in coupling between steer and drive motor */
static double couplingFactor = 0.5;
