/*
 * Copyright (c) 2011 CNRS/LAAS
 *
 * Permission to use, copy, modify, and/or distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

#include <sys/types.h>
#include <pthread.h>
#include <signal.h>
#include <stdbool.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include <portLib.h>
#include <taskLib.h>
#include <errnoLib.h>

#include <mor/pscan.h>
#include <mor/harmonica.h>
#include <mor/relayboard.h>
#include <mor/morLib.h>

int done = 0;

void 
ctrlc(int sig)
{
	done++;
}


int 
main(int argc, char *argv[])
{
	MOR_STR *mor;
	char *name = "/dev/pcan24";

	mor = morInit(name, "/dev/ttyUSB0", false, false);
	if (mor == NULL) 
		exit(2);
	printf("morInit done\n");

	signal(SIGINT, ctrlc);
	signal(SIGHUP, ctrlc);
	morStartRelayboardTask(mor);
	while (!done) {
		usleep(500000);
	}
	relayboardUpdate(mor->relayboard, 
	    "                                                            ");
	morEnd(mor);
	printf("bye\n");
	exit(0);
}
